<% try { %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Room Schedule Selection</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="RoomRequestStyle.css" rel="stylesheet" type="text/css">

</head>

<body>
<% 
/*----------------------------------------------------------------------------------------------
							R O O M  S E L E C T I O N . J S P
------------------------------------------------------------------------------------------------
Purpose:	Users view this page to select room schedules for viewing.  When
			submit is pressed the request is sent to RoomScheduleResults for processing
			and calendar display.  
Author:		Kyle A Cunningham <kcunning@cs>
Assumptions:	None
Created:	2005-07-20
------------------------------------------------------------------------------------------------
								M O D I F I C A T I O N S
------------------------------------------------------------------------------------------------ 
02/21/2006		Created RoomRequest.js to elimiate need for declaration of commonly used javascript
				functions in RoomSelection and RoomRequestResults.jsp.  Removed javascript section
				and modified calls by adding javascript: tag.
02/24/2006		Surrounded all code with try/catch block to catch any errors.  Errory message is
				displayed at bottom of page.  Could not get just an error table to show up, constantly
				kept putting the dropdowns in first, so should work that out later.
----------------------------------------------------------------------------------------------*/
%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.sql.*"%>
<%@ page import="java.io.*"%>
<%@page import="org.apache.log4j.Logger"%>
<%@page import="edu.cmu.radar.vendor.*"%>
<%@ page errorPage="Error.jsp" isErrorPage="false" %>

<%!


private int wordToIntMonth(String month) {
        int m;
        if(month.equalsIgnoreCase("January") || month.equalsIgnoreCase("Jan")) {
            m=0;
        } else if(month.equalsIgnoreCase("February") || month.equalsIgnoreCase("Feb")) {
            m=1;
        } else if(month.equalsIgnoreCase("March") || month.equalsIgnoreCase("Mar")) {
            m=2;
        } else if(month.equalsIgnoreCase("April") || month.equalsIgnoreCase("Apr")) {
            m=3;
        } else if(month.equalsIgnoreCase("May")) {
            m=4;
        } else if(month.equalsIgnoreCase("June") || month.equalsIgnoreCase("Jun")) {
            m=5;
        } else if(month.equalsIgnoreCase("July") || month.equalsIgnoreCase("Jul")) {
            m=6;
        } else if(month.equalsIgnoreCase("August") || month.equalsIgnoreCase("Aug")) {
            m=7;
        } else if(month.equalsIgnoreCase("September") || month.equalsIgnoreCase("Sep")) {
            m=8;
        } else if(month.equalsIgnoreCase("October") || month.equalsIgnoreCase("Oct")) {
            m=9;
        } else if(month.equalsIgnoreCase("November") || month.equalsIgnoreCase("Nov")) {
            m=10;
        } else if(month.equalsIgnoreCase("December") || month.equalsIgnoreCase("Dec")) {
            m=11;
        } else {
            m=-1;
            /* throw exception here?? */
        }
        return m;
}

/**/
    // here's where we'd make radar.properties load from c:/radar/run
    // (for tomcat, e.g.)
    private void addProps(Properties ret, String filename) {
	Logger logger = Logger.getLogger("RoomRequestResults.jsp");
	String home = System.getProperty("user.home");
	logger.debug("user.home is '" + home + "'");
	InputStream is;
	if (null != home) {
	    File f = new File(home + File.separator + filename);
	    if (f.exists()) {
		logger.debug("reading " + f + " first");
		try {
		    is = new FileInputStream(f);
		    ret.load(is);
		} catch (Exception e) {
		    logger.error(f + ": " + e);
		}
	    } else
		logger.debug(f + ": is not a file");
	}
	File f = new File(filename);
	if (f.exists()) {
	    logger.debug("now reading " + f);
	    try {
		is = new FileInputStream(f);
		ret.load(is);
	    } catch (Exception e) {
		logger.error(filename + ": " + e);
	    }
	} else
	    logger.debug(f + ": doesn't exist, moving on");
    }
	
/**/
%>
<%
    ResultSet rs = null;

    DatabaseConnectivity dcon = new DatabaseConnectivity();
    String query = "SELECT building, room, cmradarID from conferenceRooms order by building";
    //String query = rb.getString("roomRequestQuery");
    rs = dcon.submitQuery(query);

%>
<script src="RoomRequest.js"></script>

<form action="RoomRequestResults.jsp" name="selectionForm" method="post">
<!-- 
KAC 02/21/2006 - added hidden var so checkSubmission() script could be shared between pages.
-->
  <input type="hidden" name="roomID" value="0">
  <p>&nbsp;</p>
  <table class="tableTan">
    <tr> 
      <td colspan="4" class="divLineBlack"><div align="left"><font class="title">Room 
          Schedule Selection</font></div></td>
    </tr>
    <tr> 
      <td colspan="4"> <div class="divLine"></div>
        <p>Use the checkboxes below to choose which room schedules you would like 
          to view. <br>
          <br>
          When your selections are complete, click the &quot;Submit&quot; button. 
        </p></td>
    </tr>
    <% ResourceBundle rb = ResourceBundle.getBundle("properties/conferenceDays");
Properties props=new Properties(System.getProperties());
addProps(props, "user.properties");
addProps(props, "radar.properties");
String[] startDate = props.getProperty("radar.countdown.date").split(" "); // property looks like: "July 16 2007 00:00"
int numDays = Integer.parseInt(props.getProperty("radar.conference.days"));
Calendar cal = Calendar.getInstance();
cal.set(new Integer(startDate[2]).intValue(), wordToIntMonth(startDate[0]), new Integer(startDate[1]).intValue());
NumberFormat nf = NumberFormat.getIntegerInstance();
nf.setMaximumFractionDigits(0);
nf.setMinimumIntegerDigits(2);
nf.setMaximumIntegerDigits(2);
String printDate = nf.format((cal.get(Calendar.MONTH))+1) + "." + nf.format(cal.get(Calendar.DATE)) + "." + cal.get(Calendar.YEAR);
    %>
    
		<tr> 
      <td class="jumpDiv">Select a day: </td>
      <td class="jumpDiv" colspan="3">
<select name="requestDate" id="requestDate">
          <option value="<%=printDate%>" selected><%=printDate%></option>
<!--          <option value="< %=rb.getString("day1")% >" selected>< %=rb.getString("day1")% ></option>
 -->
          <% 	int i = 2;
	    // while (i<18)	
			while (i <= numDays) { 
cal.add(Calendar.DAY_OF_YEAR, 1);
printDate = nf.format((cal.get(Calendar.MONTH))+1) + "." + nf.format(cal.get(Calendar.DATE)) + "." + cal.get(Calendar.YEAR);
				String day = "day" + i;  %>
<!--          <option value="< %=rb.getString(day)% >">< %=rb.getString(day)% ></option>
 -->
<option value="<%=printDate%>"><%=printDate%></option>
          <% i++; 
			} // end while %>
        </select></td>
	</tr>
    <tr> 
      <td class="jumpDiv">Time range: </td>
      <td class="jumpDiv" colspan="3">
<select name="startTime" id="select">
          <option value="" selected>Start Time</option>
          <option value="">----------</option>
          <% i = 1;
	    	while (i < 30) { 
				String t = "t" + i;  %>
          <option value="<%=rb.getString(t)%>"><%=TimeFormat.format(rb.getString(t))%></option>
          <% //i = i +2;
				i++; 
			} // end while %>
        </select></td>
	</tr>
    <tr> 
      <td >&nbsp; </td>
      <td class="jumpDiv" colspan="3">
<select name="endTime" id="select4" onChange="javascript:checkMeetingTimes(document.selectionForm)">
          <option value="" selected>End Time</option>
          <option value="">----------</option>
          <% i = 1;
	    	while (i < 30) { 
				String t = "t" + i;  %>
          <option value="<%=rb.getString(t)%>"><%=TimeFormat.format(rb.getString(t))%></option>
          <% //i = i +2;
				i++; 
			} // end while %>
        </select></td>
	</tr>
    <tr> 
      <td class="jumpDiv">Jump to a building: </td>
      <td class="jumpDiv" colspan="3">
<select name="quickSelect" id="select5" onChange = "javascript:checkSelection(document.selectionForm)">
          <option value="flagstaff" selected>Flagstaff</option>
          <option value="mehrabian">Mehrabian</option>
          <option value="stever">Stever</option>
          <option value="uc">University Center</option>
        </select></td>
	</tr>
    <% 
		String building = new String("foo");
		String roomName = new String("foo");
		String roomID = new String("foo");
		String altRoomID = new String("foo");
		String temp = new String("foo");
		int counter = 0;
		//int temp = "String";
		while (rs.next()) {
			building = rs.getString(1);		//building
			roomName = rs.getString(2);		//room
			roomID = rs.getString(3);		//cmradarID
			
			if (!building.equals(temp)) {  %>
    			<tr> 
      				<% // this is the spacer line %>
	  				<td>&nbsp;</td>
    			</tr>
    			<tr> 
      				<td colspan="4" class="divLineBlack"><font class="smallTitle"><%=building%></font> 
        				<a href="#" target="_top">up</a> </td>
    				</tr>
    			<tr> 
      				<td colspan="4"><div class="divLine"></div></td>
    			</tr>
    
   				 <%	temp = building; 
					// move back one row to get the value of the first room
					counter = 0 ;
					rs.previous();
			} // end if
			
			else {    
    			if (counter == 0) {  %>			
				<tr>
				<% } // end if %> 
      			<td><input type="checkbox" class="checkbox" name="<%=roomID%>" value="<%=roomID%>" id="<%=roomID%>"> 
        			<%=roomName%></td>
    			<% if (counter == 3) { // end the row 
					counter = 0; %>			
					</tr>
					<% } // end if
						else { // increment the counter 
						counter++;
						} // end else	
				 } // end else 
			} // end while	%>
    
    	<tr>
			<td colspan="4">&nbsp;</td>
		</tr>	
		<tr> 
      		<td colspan="4"><div class="jumpDiv" align="center"> 
          		
          <input name="submit" type="submit" class="input" id="submit"
		  			onClick="javascript: return checkSubmission(document.selectionForm)" value="Submit Request">
        		</div>
			</td>
    	</tr>
<% dcon.closeDBConnection(); %>
  </table>
  </form>
</body>
</html>
<%	
} // end try block
catch (Exception e) { %> 
    <table class="tableTan">
    <tr>
      <td> 
        
      <p class="title">Oops!</p>
        </td>
    </tr>
  
  
	
	<tr><td class="errorText">RoomRequest experienced an 
    error that prevents the system from processing your request.</td></tr>
    
	<% 
		e.printStackTrace();
		String strError = e.toString();
		%>
    <tr>
		<td>
		Here is the error: <b><%=strError%></b>
		</td>
	</tr>
    <tr>
		<td>
		A stack trace has been printed to the Tomcat stdout log.<BR><BR>
		Please inform your experimentor of this error. 
		</td>
	</tr>	
    </table>
	<%	
	//throw new JSPException(e.toString());
	  } %>


