package edu.cmu.radar.vendor;
/*************************************************************************************************************
 *				 				S  E  N  D  E  M  A  I  L  .  J  A  V  A									 *
 *************************************************************************************************************
 * Purpose: 	This java program provides the ability to send email.
 * Functionality:	sendEmail.java accepts args from users, opens up the Socket, connects to the specified
 * 					mailServer and sends the message.  Once message is sent the connection is closed.
 * Input:	no inputs create a sendEmail object
 * Output:	outputs email message through BufferedReader to mailServer
 * Dependencies:	none
 * Author: 		Kyle A Cunningham <kcunning@cs.cmu.edu> / Jordan Hayes
 ************************************************************************************************************/

/******  dont need these when using Vendor.sendMail()
import javax.mail.Folder;
import javax.mail.Message;
import javax.mail.Session;
import javax.mail.Store;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import com.sun.mail.imap.IMAPFolder;
*/

import edu.cmu.cs.radar.core.Vendor;


public class sendEmail {

    /****  also removed as not used by Vendor.sendMail()
    private static Session s_session = Session.getInstance(System.getProperties()); */ 

    private static Vendor v = null;

    public void sendMail(String user, String pass, String host,
      String to, String from, String subject, String body) {
    	try {

	    if (null == v)
		v = new Vendor();
	    v.sendMail(user, pass, host, to, from, subject, body);

	    /*  removed and superceeded by 3 lines above
    		Store s = s_session.getStore("imap");
    		s.connect(host, user, pass);
    		Folder f = s.getFolder("vendors");
    		if (false == f.exists()) {
    			if (false == f.create(Folder.HOLDS_MESSAGES)) {
    				out("EXCEPTION: sendEmail.sendMail(): Can't create vendors folder");
    				return;
    			} // end if
    		} // end if
    		IMAPFolder vendors = (IMAPFolder)f;
    		MimeMessage mm = new MimeMessage(s_session);
    		mm.setRecipients(Message.RecipientType.TO, to);
    		mm.setFrom(new InternetAddress(from));
    		mm.setSubject(subject);
    		mm.setText(body + "\n");
		mm.setSentDate(new java.util.Date());
    		vendors.open(Folder.READ_WRITE);
    		vendors.appendMessages(new Message[] { mm });
    		vendors.close(false);
	    */

    	} // end try
    	catch (Exception e) {
    		out("EXCEPTION: sendEmail.sendMail():\n\t " + e);
    		e.printStackTrace();
    	} // end catch
    } // end sendMail()

    public static void main(String[] args) {
    	sendEmail s = new sendEmail();
    	s.sendMail(
    			/* user */	"rwx2995",
				/* pass */	"rwx2995",
				/* host */	"zooks.radar.cs.cmu.edu",
				/* to */	"Kyle Cunningham <kcunning@cs.cmu.edu>",
				/* from */	"Santa Claus <bigman@north.pole>",
				/* subj */	"That list ...",
    			/* body */	"Don't forget to\ncheck it twice!\n\n--SC");
    } // end main()

    private void out(String s) { System.out.println(s); }

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
} 										// end sendEmail.java
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


