<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Room Availability - Results</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link href="RoomRequestStyle.css" rel="stylesheet" type="text/css">
</head>

<% 
/*---------------------------------------------------------------------------------------------
						R O O M S C H E D U L E R E S U L T S . J S P 
-----------------------------------------------------------------------------------------------						
Purpose:	This jsp file is called from RoomSelection.jsp and is used to query the CMRadar
			sharedroomcalendar and meeting files. Once calendar information is gathered
			html tables are dynamically created to display the schedule information.  Users then
			have the option to schedule a room after viewing the results.
Author:		Kyle A Cunningham <kcunning@cs.cmu.edu>
Assumptions: none
Created:	2005-07-20
------------------------------------------------------------------------------------------------
								M O D I F I C A T I O N S
------------------------------------------------------------------------------------------------ 
10/18/2005		Removed if logic so that all rooms requested are displayed, even if there is no
				meeting data
12/8/2005		Mods to improve display with IE - added <nobr> tag to stop line breaks at hyphens,
				Added jscript to open new window to diplay meeting details, modified bottom table
				display to show "details" link instead of owner and type.
02/10/2006		Changed meeting-id to type String to conform with new standards in CMRadar input
				files.  Added logic to check for room __UNAVAILABLE__.
02/21/2006		Created RoomRequest.js to elimiate need for declaration of commonly used javascript
				functions in RoomSelection and RoomRequestResults.jsp.  Removed shared functions
				and modified calls by adding javascript: tag.
02/23/2006		Various changes made - now grid correctly shows meetings that last all day.  Also,
				meetings that span over the specified search endTime are shown.  Adjustments made
				to correctly display 30 minute intervals.
02/24/2006		Added try/catch block for exception/error handling.  Page also uses Error.jsp.				
----------------------------------------------------------------------------------------------*/
%>

<script src="RoomRequest.js"></script>

<script type="text/javascript" language="JavaScript">
/*----------------------------------------------------------------
* KAC 12/8/2005 -> Added method to open small window to display 
				   meeting details
-----------------------------------------------------------------*/
/*----------------------------------------------------------------
goNewWin(page)
Purpose: 	called when user clicks "details" in a meeting cell
			calls MeetingDetails.jsp which uses request object to
			pull out meeting data
Input:		page (MeetingDetails.jsp...)
Output:		none
----------------------------------------------------------------*/
function goNewWin(page) {
	// Place the window
	var NewWinPutX=710;
	var NewWinPutY=280;

	TheNewWin = window.open(page, 'newWindow', config='height=120, width=200', 'fullscreen=yes,toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=no');
	//TheNewWin.moveTo(NewWinPutX,NewWinPutY);
} // end goNewWin()

</script>


<%@page import="java.sql.*"%>
<%@page import="java.util.*"%>
<%@page import="java.math.*"%>
<%@page import="java.io.*"%>
<%@page import="org.apache.log4j.Logger"%>
<%@page import="edu.cmu.radar.vendor.RoomRequest.RoomSearch"%>
<%@page import="edu.cmu.radar.vendor.RoomRequest.RoomMeeting"%>
<%@page import="edu.cmu.radar.vendor.RoomRequest.Meeting"%>
<%@page import="edu.cmu.radar.vendor.*"%>
<%@page errorPage="/Error.jsp" isErrorPage="false" %>

<% 

try {



/*--------------------------------------------------------------------
	Methods
--------------------------------------------------------------------*/
%>
<%/*------------------------------------------------------------------
	public Vector setupRoomVector()
	Purpose:  called to read the a relation containing room name info.
			  If room currently read in is found in the request stream
			  that room is added to the room vector.
	Input:	  ResultSet rs, HttpServletRequest request
	Output:	  Vector v <room vector>
--------------------------------------------------------------------*/%>
<%! public Vector setupRoomVector(ResultSet rs, HttpServletRequest request) {
		Vector v = new Vector();
		String roomID = new String("foo");
		String roomRequest = new String("foo");
		try {
			while (rs.next()) {
				roomID = rs.getString("cmradarID"); 	//cmradarID
				roomRequest = request.getParameter(roomID);
				if (roomRequest != null) {
					v.add(roomID); 
					//System.out.println("added " + roomRequest + "\n");
				} // end if
			} // end while
		} // end try
		catch (SQLException e) {
			System.out.println("EXCEPTION! RoomScheduleResults.jsp:\n\t" + e);}
	return v;
  } // end setupRoomVector()
%>
<%/*------------------------------------------------------------------
	public Vector setupColumnVector()
	Purpose:  called to populate a vector with column headers.
			  Column headers are half-hour time intervals, beginning
			  at 06:00 and ending at 02:00
	Input:	  none
	Output:	  Vector v <column vector>
--------------------------------------------------------------------*/%>
<%! public Vector setupColumnVector() {
		int hour = 6;
		int minute = 00;
		String amOrPm = "am";
		
		Vector vector = new Vector();

		while (true) {
			StringBuilder builder = new StringBuilder(15);
			formatTime(hour, minute, amOrPm, builder);
			builder.append(" - ");

			if (minute == 30) {
				minute = 0;
				hour++;

				if (hour == 12) {
					if (amOrPm.equals("pm")) {
						hour = 0;
						amOrPm = "am";
					} else {
						amOrPm = "pm";
					}
				} else if (hour == 13 && amOrPm.equals("pm")) {
					hour = 1;
				}
			} else {
				minute = 30;
			}
			
			formatTime(hour, minute, amOrPm, builder);			
			
			String fmtTime = builder.toString();
			vector.add(fmtTime);
			
			if (fmtTime.equals("01:30am - 02:00am")) {
				break;
			}
		}		
		
		return vector;	
	} // end setupColumnVector()
	
	public void formatTime(int hour, int minute, String amOrPm, StringBuilder builder) {
		if (hour < 10) {
			builder.append(0);
		}
		builder.append(hour).append(":");
		if (minute < 10) {
			builder.append(0);
		}
		builder.append(minute);
		builder.append(amOrPm);
	}
%>

<%/*------------------------------------------------------------------
	public String createMeetingDetails()
	Purpose:  called to create a string listing a particular meeting's 
			  details (owner, start/end times, meeting type).
	Input:	  String owner, String startTime, String endTime, String meetingType
	Output:	  String <details>
--------------------------------------------------------------------*/%>
<%! public String createMeetingDetails(String owner, String startTime, String endTime, String meetingType) {
		String s = "Owner:" +owner + "<br>" + "Type:" +meetingType; 
		//String link = "<a href=# onClick = goNewWin(\"/myapp/webForms/RoomRequest/MeetingDetails.jsp?owner=" + owner + "&type=" + 
			//		meetingType + "&startTime=" + startTime + "&endTime=" + endTime + "\")>details</a>" ;
		//return link;
		return s;
		
} // end createMeetingDetails()
%> 

<%! public String setUserStartTime(HttpServletRequest request) {
		return (request.getParameter("startTime"));
	} // end setUserStartTime
	
	public String setUserEndTime(HttpServletRequest request) {
		return (request.getParameter("endTime"));
	} // end setUserEndTime	



/**/
    // here's where we'd make radar.properties load from c:/radar/run
    // (for tomcat, e.g.)
    private void addProps(Properties ret, String filename) {
	Logger logger = Logger.getLogger("RoomRequestResults.jsp");
	String home = System.getProperty("user.home");
	logger.debug("user.home is '" + home + "'");
	InputStream is;
	if (null != home) {
	    File f = new File(home + File.separator + filename);
	    if (f.exists()) {
		logger.debug("reading " + f + " first");
		try {
		    is = new FileInputStream(f);
		    ret.load(is);
		} catch (Exception e) {
		    logger.error(f + ": " + e);
		}
	    } else
		logger.debug(f + ": is not a file");
	}
	File f = new File(filename);
	if (f.exists()) {
	    logger.debug("now reading " + f);
	    try {
		is = new FileInputStream(f);
		ret.load(is);
	    } catch (Exception e) {
		logger.error(filename + ": " + e);
	    }
	} else
	    logger.debug(f + ": doesn't exist, moving on");
    }
	
/**/


/*------------------------------------------------------------------
	public int getNumTimeSlots()
	Purpose:  called to determine the size of the meeting arrays based on 
			  user-specified start and end times.  
	Input:	 String startTime, String endTime
	Output:	  int <numTimeSlots>
----------------------------------------------------------------------
* KAC 2/23/2006 -> added processing of start and endMinutes to accomodate
*                  processing of 30 minutes meetings in the display.
--------------------------------------------------------------------*/

	public int getNumTimeSlots(String startTime, String endTime) {			
		if (startTime.length() == 4) {
			startTime = "0" + startTime;
		}
		
		int startHour = Integer.valueOf(startTime.substring(0,2)).intValue();
		int startMinute = Integer.valueOf(startTime.substring(3)).intValue();
		
		if (endTime.length() == 4) {
			endTime	= "0" + endTime;
		}
		
		int	endHour = Integer.valueOf(endTime.substring(0,2)).intValue();
		int	endMinute = Integer.valueOf(endTime.substring(3)).intValue();
		
		//System.out.println("startHour: " + startHour + ", endHour: " + endHour);
		//System.out.println("startMinute: " + startMinute + ", endMinute: " + endMinute);
		
		if (startMinute > endMinute) {
			return (Math.abs(endHour - startHour)*2 - 1);
		}
		if (startMinute < endMinute){
			return (Math.abs(endHour - startHour)*2 + 1);
		}
		else {
			return (Math.abs(endHour - startHour)*2);
		}
	}

	public int getArrayIndex(String startTime){
		if (startTime.equals("6:00")) {return 0;}
		if (startTime.equals("6:30")) {return 1;}
		if (startTime.equals("7:00")) {return 2;}
		if (startTime.equals("7:30")) {return 3;}
		if (startTime.equals("8:00")) {return 4;}
		if (startTime.equals("8:30")) {return 5;}
		if (startTime.equals("9:00")) {return 6;}
		if (startTime.equals("9:30")) {return 7;}
		if (startTime.equals("10:00")) {return 8;}
		if (startTime.equals("10:30")) {return 9;}
		if (startTime.equals("11:00")) {return 10;}
		if (startTime.equals("11:30")) {return 11;}
		if (startTime.equals("12:00")) {return 12;}
		if (startTime.equals("12:30")) {return 13;}
		if (startTime.equals("13:00")) {return 14;}
		if (startTime.equals("13:30")) {return 15;}
		if (startTime.equals("14:00")) {return 16;}
		if (startTime.equals("14:30")) {return 17;}
		if (startTime.equals("15:00")) {return 18;}
		if (startTime.equals("15:30")) {return 19;}
		if (startTime.equals("16:00")) {return 20;}
		if (startTime.equals("16:30")) {return 21;}
		if (startTime.equals("17:00")) {return 22;}
		if (startTime.equals("17:30")) {return 23;}
		if (startTime.equals("18:00")) {return 24;}
		if (startTime.equals("18:30")) {return 25;}
		if (startTime.equals("19:00")) {return 26;}
		if (startTime.equals("19:30")) {return 27;}
		if (startTime.equals("20:00")) {return 28;}
		if (startTime.equals("20:30")) {return 29;}
		if (startTime.equals("21:00")) {return 30;}
		if (startTime.equals("21:30")) {return 31;}
		if (startTime.equals("22:00")) {return 32;}
		if (startTime.equals("22:30")) {return 33;}
		if (startTime.equals("23:00")) {return 34;}
		if (startTime.equals("23:30")) {return 35;}
		if (startTime.equals("24:00")) {return 36;}
		if (startTime.equals("0:30")) {return 37;}
		if (startTime.equals("1:00")) {return 38;}
		if (startTime.equals("1:30")) {return 39;}
		else return 0;
	} // end getArrayIndex()
	  
%>
<%
/*---------------------------------------------------------------
 	END METHOD SECTION
----------------------------------------------------------------*/
%>	
<%	//System.out.println("\n\n------------------------START OF PROCESSING --------------------------------");
	ResultSet rs = null;	
    DatabaseConnectivity dcon = new DatabaseConnectivity();
	String query = "SELECT building, room, cmradarID from conferenceRooms order by building";
	//String query = rb.getString("roomRequestQuery");
	rs = dcon.submitQuery(query);
		
	String requestDate = request.getParameter("requestDate");
	String userStartTime = setUserStartTime(request);
	String userEndTime = setUserEndTime(request);
	int numTimeSlots = getNumTimeSlots(userStartTime, userEndTime);
	Vector rooms = setupRoomVector(rs, request);
	rs.close();
	//System.out.println("\nDEBUG: Room vector size is: " + rooms.size() +"\nnumTimeSlots: " + numTimeSlots);
	
	Vector columns = setupColumnVector();
	int cellCounter = 0; 	
	RoomSearch roomSearch = new RoomSearch(); 
	String[] tableCellArray = new String[41];
	String[] tableMeetingData = new String[41]; 
	int startArrayDataCell = getArrayIndex(userStartTime);
	int endArrayDataCell = startArrayDataCell + numTimeSlots;  
	
	ResourceBundle rb = ResourceBundle.getBundle("properties/conferenceDays");
%>
<body>
<form name="requestForm" action="CheckRoomRequest.jsp" method="post">
<input type="hidden" name="requestDate" value="<%=requestDate%>">
  
    <table class="tableTan" width="48%" height="99" border="0" cellpadding="0">
      <tr> 
        <td colspan="4" class="divLineBlack"> <div class="title">Room Search Results</div></td>
      </tr>
      <tr> 
        <td colspan="4"><div class="divLine"></div></td>
      </tr>
      <tr> 
        <td colspan="4" class="divLineBlack"><div class="smallTitle">Search Criteria:</div></td>
      </tr>
      <tr> 
        <td colspan="4"><div class="divLine"></div></td>
      </tr>
      <tr> 
        <td width="83">&nbsp;</td>
        <td width="86" class="data">Date:</td>
        <td colspan="2" class="data"><%=requestDate%></td>
      </tr>
      <tr> 
        <td height="18">&nbsp;</td>
        <td height="18" class="data">Start Time:</td>
        <td height="18" colspan="2" class="data"><%=TimeFormat.format(userStartTime)%></td>
      </tr>
      <tr> 
        <td height="18">&nbsp;</td>
        <td height="18" class="data">End Time:</td>
        <td height="18" colspan="2" class="data"><%=TimeFormat.format(userEndTime)%></td>
      </tr>
      <tr> 
        <td height="18">&nbsp;</td>
        <td height="18" class="data">&nbsp;</td>
        <td height="18" class="data">&nbsp;</td>
        <td height="18" class="data"><div align="right"><a href="RoomSelection.jsp">Back 
          to Search Page</a></div></td>
      </tr>
      <tr> 
        <td colspan="4" class="divLineBlack"> <div class="smallTitle"> Request 
            a Room:</div></td>
      </tr>
      <tr> 
        <td colspan="4"><div class="divLine"></div></td>
      </tr>
      <tr> 
        <td width="83">&nbsp;</td>
        <td>Date: </td>
        <td colspan="2"><input name="disabledRequestDate" type="text" disabled="disabled" class="input" id="disabledRequestDate" value="<%=requestDate%>"></td>
      </tr>
      <tr> 
        <td height="18">&nbsp;</td>
        <td><div class="data">Start Time: </div></td>
        <td colspan="2"><select name="startTime" id="select">
            <option value="" selected>Start Time</option>
            <option value="">----------</option>
            <% 	int i=1;
				String t = "t";		
				while(i <= 28) {
					t = "t" + i;
					if (userStartTime.equals(rb.getString(t))){ %>
            <option value="<%=rb.getString(t)%>"><%=TimeFormat.format(rb.getString(t))%></option>
            <%	i++;	
						int d = 0;
						while (d < numTimeSlots) {
							t = "t" + i; %>
            <option value="<%=rb.getString(t)%>"><%=TimeFormat.format(rb.getString(t))%></option>
            <%		d++;
							i++;
						} // end while
					} // end if
					i++;
				} // end while %>
          </select> <span class="userNote">*</span></td>
      </tr>
      <tr> 
        <td height="18">&nbsp;</td>
        <td><div class="data">End Time: </div></td>
        <td colspan="2"><select name="endTime" id="select2" onChange="javascript: checkMeetingTimes(document.requestForm)">
            <option value="" selected>End Time</option>
            <option value="">----------</option>
            <% 	i=1;
				t = "t";
				while(i <= 28) {
					t = "t" + i;
					if (userStartTime.equals(rb.getString(t))){ %>
            <option value="<%=rb.getString(t)%>"><%=TimeFormat.format(rb.getString(t))%></option>
            <%	i++;	
						int d = 0;
						
						while (d < numTimeSlots) {
							t = "t" + i; %>
            <option value="<%=rb.getString(t)%>"><%=TimeFormat.format(rb.getString(t))%></option>
            <%		d++;
							i++;
						} // end while
					} // end if
					i++;
				} // end while %>
          </select> <span class="userNote"> *</span></td>
      </tr>
      <tr> 
        <td height="18">&nbsp;</td>
        <td><div class="data">Room: </div></td>
        <td colspan="2" class="userNote"> <select name="roomID" id="select3">
            <option value="" selected>Room Name</option>
            <option value="">----------</option>
            <% i = 0;
				while(i < rooms.size()) { %>
            <option value="<%=(String)rooms.get(i)%>"><%=(String)rooms.get(i)%></option>
            <% 		i++;
				} // end while
			%>
          </select> <span class="userNote">*</span></td>
      </tr>
      <tr> 
        <td height="18" class="data">&nbsp;</td>
        <td>&nbsp;</td>
        <td colspan="2" class="userNote">* indicates required fields</td>
      </tr>
      <tr> 
        <td height="18" class="smallerTitle">&nbsp;</td>
        <td>&nbsp;</td>
        <td width="270">&nbsp;</td>
        <td width="127"><div align="right"> 
            <input name="submitButton" type="submit" class="input" id="submitButton2"
	  	onClick = "javascript: return checkSubmission(document.requestForm)" value="Submit Request">
          </div></td>
      </tr>
    </table>
	
</form>
<br>
<div>
<table>
	<%	
	//-------------------------- THIS IS THE BIGGEN! -----------------------------
	for (int k=0; k<=rooms.size(); k++) {
	//----------------------------------------------------------------------------
	
	 if (k == 0) { %>
		<tr> 
			
			<td class="tdWithBorder"><nobr><%=columns.get(0)%></nobr></td> <!-- This is the ROOM column header --> 
		<%	// we want to print the column headers so skip out of any meeting processing
			/*---------------------------------------------------------------------------
			 * KAC 12/8/2005 -> added <nobr> tags to stop IE from interpreting "-" as \n
			 * ------------------------------------------------------------------------*/
			 
			 for (int tableCell = startArrayDataCell+1; tableCell <= endArrayDataCell; tableCell++) 
				{%><td class="tdWithBorder"><nobr><%=columns.get(tableCell)%></nobr></td><%} %>
			
		</tr>
	<%} // end if 
	 
	else { 
	  //
	%>
		
  <tr> 
    <%
		///rb = ResourceBundle.getBundle("properties/cmradarFilePaths");
		///ArrayList roomSearchData = roomSearch.getMeetingsForRoom(rb.getString("meetings"), rb.getString("calendar"), (String)rooms.get(k-1));

		Properties props = new Properties(System.getProperties());
		addProps(props, "radar.properties");
		addProps(props, "user.properties");
		ArrayList roomSearchData = roomSearch.getMeetingsForRoom(props.getProperty("radar.vendor.file.meetings"), props.getProperty("radar.vendor.file.calendar"), (String)rooms.get(k-1));

		for (int j=0; j<tableCellArray.length; j++){tableCellArray[j] = "FFFFFF";}
		/*---------------------------------------------------------------------------
		 * KAC 10/18/2005 -> comment out to show all rooms requested, even if empty
		 ----------------------------------------------------------------------------*/
		//if (!roomSearchData.isEmpty()) {
			RoomMeeting rm = new RoomMeeting();
			Meeting m = new Meeting();
			String startTime = new String();
			String endTime = new String();
			String owner = new String();
			String meetingType = new String();
			String attendees = new String();
			String roomID = new String();
			String meetingID = new String();
			int duration = 99999;
			//int meetingID = 99999;
			//String meetingID = new String();
			int arrayIndex = 99999;
			int size = 0;
			if (!roomSearchData.isEmpty()) {
				size = roomSearchData.size();
			} ///else
			for (int p=0; p<size; p++) {
				rm = (RoomMeeting)roomSearchData.get(p);
				if (rm.getDate().equals(requestDate)){  // we have a match for the requestDate, get the meeting data
					m = rm.getMeeting();
					startTime = rm.getStartTime();
					endTime = rm.getEndTime();
					//owner = m.getInitiator();
					//meetingType = m.getType();
					meetingID = m.getId();
					/*--- mod here------------------*/
					if (meetingID.startsWith("__UNAVAILABLE__")) {
						owner = "Unavailable";
						meetingType = "";
					}
					else {
						owner = m.getInitiator();
						meetingType = m.getType();
					}
			                if ("-1".equals(meetingType))
			                        meetingType = "unknown";
			                if ("corrupted".equalsIgnoreCase(meetingType)) {
                                                meetingType = "unavailable";
			                        owner = "";
			                 }
					// -----------------
					roomID = rm.getRoomId();
					duration = m.getDurationBlocks();
					attendees = m.getAttendants();
					arrayIndex = rm.getArrayIndex();
					// assign all array slots meeting with occupy to deal with meetings that start before userStartTime
					int index = arrayIndex;
					String details = createMeetingDetails(owner, startTime, endTime, meetingType);
					/* ---------------------------------------------------------------------
			 		 * KAC 2/23/2006 ->	Commented out while loop below - it was unnecessary.
					 * --------------------------------------------------------------------*/
					/*while (index < (arrayIndex + duration)) {
						if (index == arrayIndex) {
							tableCellArray[index+1] = "DBDB70" + ":" + duration;
						}
						else {	// declining duration
							duration--;
							tableCellArray[index+1] = "DBDB70" + ":" + duration;
						}
						tableMeetingData[index+1] = details;
						index++;
					} // end while		
					*/
					tableCellArray[index+1] = "DBDB70" + ":" + duration;
					tableMeetingData[index+1]= details;
					
					%>
     		<% }  // end if %>
    	<%	} // end for int p



			/*  gh:
			 *  find the first meeting before the user-selected start time
			 *  (the first time displayed by the table here) and copy its
			 *  information into the user-selected start time cell, while
			 *  adjusting the duration appropriately.  this allows us to
			 *  visualize meetings that start before the table start time
			 *  but actually run into the times shown in the table
			 */
			if ("FFFFFF".equals(tableCellArray[startArrayDataCell+1])) { // the first cell in our display is empty, so check for a previous meeting...
			    int done = 0;
			    for (int cellWalker = startArrayDataCell; (cellWalker>=0) && (done==0); cellWalker--) { // walk backwards til we find a meeting (and thus are done) or hit the beginning of the day...
			        String[] checkDuration = tableCellArray[cellWalker].split(":");
			        if (checkDuration.length > 1) { // so we found a meeting...
			            done = 1; // assuming schedules are consistent: the meeting either ran into our 'viewing window' (and we updated the display as such) or it fell short and thus no other meeting runs into our window, so we are done looking.
			            int thisDuration = Integer.valueOf(checkDuration[1]).intValue();
			            if (thisDuration > (1 + startArrayDataCell - cellWalker)) { // if the meeting runs into our window, update the first cell to be displayed so it represents this meeting
			                tableCellArray[startArrayDataCell+1] = "DBDB70" + ":" + (thisDuration-(1 + startArrayDataCell - cellWalker)); // adjust duration to account for cells we arent displaying (subtract number of steps we have taken)
			                tableMeetingData[startArrayDataCell+1] = tableMeetingData[cellWalker];
			            }
			        }
			    }
			}
			/*  end gh block 
			 */



			roomSearchData.clear();	 
			String[] cellSplit = new String[2];
			cellCounter = startArrayDataCell+1; // offset for ROOM cell %>
    <td colspan="1"><%=(String)rooms.get(k-1)%></td>  <!--ROOM NAME HERE -->
			<%
			while (cellCounter <= endArrayDataCell) {
					cellSplit = tableCellArray[cellCounter].split(":");
					
					// empty slot so display the default color
					if (cellSplit.length == 1) { %>
						<td class="tdWithBorder" bgcolor=<%=tableCellArray[cellCounter]%> colspan="1" id="<%=cellCounter%>">&nbsp;</td>
						<%	cellCounter++; 
					} // end if
					
					// there is a meeting for this slot, so determine it's duration and adjust colspan accordingly
				
					else { 
						if ((cellCounter + Integer.valueOf(cellSplit[1]).intValue()-1) > endArrayDataCell) {%>
						<% /* ----------------------------------------------------------------------------
							* KAC 02/23/2006 -> Changed colspan so that meetings that last longer than the
							*					specified time range will show as continuous blocks.  
							*					endArrayDataCell is incremented by 2 to deal with the offset for
							*					printing of "Room" in first cell.  Also, cellCounter loop
												increment was changed to correspond with this change.
							------------------------------------------------------------------------------*/
						%>	
						<!--<td class="tdWithBorder" bgcolor=<%=cellSplit[0]%> colspan="1" id="<%=cellCounter%>">-->
						<td class="tdWithBorder" bgcolor=<%=cellSplit[0]%> colspan="<%=((endArrayDataCell+2)-cellCounter)%>" id="<%=cellCounter%>">
							<%=tableMeetingData[cellCounter]%></td> 
						  	<% //cellCounter++;
							   cellCounter = cellCounter + Integer.valueOf(cellSplit[1]).intValue();
						} // end if 
						
						else { %>	
						<td class="tdWithBorder" bgcolor=<%=cellSplit[0]%> colspan="<%=cellSplit[1]%>" id="<%=cellCounter%>">
								<%=tableMeetingData[cellCounter]%></td>
						<%	cellCounter = cellCounter + Integer.valueOf(cellSplit[1]).intValue(); 
						} // end else
				//	} // end else 
				} // end else %>	 
		
			<%
	
			} //end while cellCounter
			//clear out the arrays for next room iteration
			for (int n=0; n<tableCellArray.length; n++) {
				tableCellArray[n] = "";
				tableMeetingData[n] = "";
			} // end for
		/*------------------------------------------------------------------------
		 * KAC 10/18/2005 -> commented out } for if control logic
		 -----------------------------------------------------------------------*/
		// } // end if (!roomSearchData.isEmpty())
	  
	  		
	} // end else (everything other than column headers)
		
	%>
	</tr>
	<%
	
	} // end for (this is the BIGGEN!)
	%>
	</table>
	</div>
<p></p>
<BR><BR>
<div align="center"></div>
<p>
<%  
 dcon.closeDBConnection();

  }// end try
	catch (Exception e) { %> 
    <table class="tableTan">
    
    <tr>
      <td>
    <p class="title">Oops!</p>
        </td>
    </tr>
  	<tr>
		<td class="errorText">
		RoomRequest experienced an 
    error that prevents the system from processing your request.
		</td>
	</tr>
	 <% 
		e.printStackTrace();
		String strError = e.toString();
		%>
    <tr>
		<td>
		Here is the error: <b><%=strError%></b>
		</td>
	</tr>
	<tr>
		<td>
		A stack trace has been printed to the Tomcat stdout log.</b>
		</td>
	</tr>
	<tr>
		<td>
		<br>Please inform your experimentor of this error. 
		</td>
	</tr>
    
    </table>
	<%	
	  } %>
</body>
</html>
